git-submodule.sh: accept verbose flag in cmd_update to be non-quiet
[git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14    or: $dashless [--quiet] foreach [--recursive] <command>
15    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16    or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
29
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
45
46 die_if_unmatched ()
47 {
48         if test "$1" = "#unmatched"
49         then
50                 exit ${2:-1}
51         fi
52 }
53
54 #
55 # Print a submodule configuration setting
56 #
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
60 #
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules.  This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary.  If the option is
65 # not in .gitmodules either, print a default value.
66 #
67 get_submodule_config () {
68         name="$1"
69         option="$2"
70         default="$3"
71         value=$(git config submodule."$name"."$option")
72         if test -z "$value"
73         then
74                 value=$(git config -f .gitmodules submodule."$name"."$option")
75         fi
76         printf '%s' "${value:-$default}"
77 }
78
79 isnumber()
80 {
81         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82 }
83
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
88 {
89         save_config=$GIT_CONFIG_PARAMETERS
90         clear_local_git_env
91         GIT_CONFIG_PARAMETERS=$save_config
92         export GIT_CONFIG_PARAMETERS
93 }
94
95 #
96 # Add a new submodule to the working tree, .gitmodules and the index
97 #
98 # $@ = repo path
99 #
100 # optional branch is stored in global branch variable
101 #
102 cmd_add()
103 {
104         # parse $args after "submodule ... add".
105         reference_path=
106         while test $# -ne 0
107         do
108                 case "$1" in
109                 -b | --branch)
110                         case "$2" in '') usage ;; esac
111                         branch=$2
112                         shift
113                         ;;
114                 -f | --force)
115                         force=$1
116                         ;;
117                 -q|--quiet)
118                         GIT_QUIET=1
119                         ;;
120                 --reference)
121                         case "$2" in '') usage ;; esac
122                         reference_path=$2
123                         shift
124                         ;;
125                 --reference=*)
126                         reference_path="${1#--reference=}"
127                         ;;
128                 --name)
129                         case "$2" in '') usage ;; esac
130                         custom_name=$2
131                         shift
132                         ;;
133                 --depth)
134                         case "$2" in '') usage ;; esac
135                         depth="--depth=$2"
136                         shift
137                         ;;
138                 --depth=*)
139                         depth=$1
140                         ;;
141                 --)
142                         shift
143                         break
144                         ;;
145                 -*)
146                         usage
147                         ;;
148                 *)
149                         break
150                         ;;
151                 esac
152                 shift
153         done
154
155         if test -n "$reference_path"
156         then
157                 is_absolute_path "$reference_path" ||
158                 reference_path="$wt_prefix$reference_path"
159
160                 reference="--reference=$reference_path"
161         fi
162
163         repo=$1
164         sm_path=$2
165
166         if test -z "$sm_path"; then
167                 sm_path=$(printf '%s\n' "$repo" |
168                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169         fi
170
171         if test -z "$repo" || test -z "$sm_path"; then
172                 usage
173         fi
174
175         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
177         # assure repo is absolute or relative to parent
178         case "$repo" in
179         ./*|../*)
180                 test -z "$wt_prefix" ||
181                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
183                 # dereference source url relative to parent's url
184                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
185                 ;;
186         *:*|/*)
187                 # absolute url
188                 realrepo=$repo
189                 ;;
190         *)
191                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
192         ;;
193         esac
194
195         # normalize path:
196         # multiple //; leading ./; /./; /../; trailing /
197         sm_path=$(printf '%s/\n' "$sm_path" |
198                 sed -e '
199                         s|//*|/|g
200                         s|^\(\./\)*||
201                         s|/\(\./\)*|/|g
202                         :start
203                         s|\([^/]*\)/\.\./||
204                         tstart
205                         s|/*$||
206                 ')
207         if test -z "$force"
208         then
209                 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210                 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211         else
212                 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213                 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214         fi
215
216         if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
217         then
218                 eval_gettextln "The following path is ignored by one of your .gitignore files:
219 \$sm_path
220 Use -f if you really want to add it." >&2
221                 exit 1
222         fi
223
224         if test -n "$custom_name"
225         then
226                 sm_name="$custom_name"
227         else
228                 sm_name="$sm_path"
229         fi
230
231         # perhaps the path exists and is already a git repo, else clone it
232         if test -e "$sm_path"
233         then
234                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
235                 then
236                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
237                 else
238                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
239                 fi
240
241         else
242                 if test -d ".git/modules/$sm_name"
243                 then
244                         if test -z "$force"
245                         then
246                                 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
247                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
248                                 die "$(eval_gettextln "\
249 If you want to reuse this local git directory instead of cloning again from
250   \$realrepo
251 use the '--force' option. If the local git directory is not the correct repo
252 or you are unsure what this means choose another name with the '--name' option.")"
253                         else
254                                 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
255                         fi
256                 fi
257                 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
258                 (
259                         sanitize_submodule_env
260                         cd "$sm_path" &&
261                         # ash fails to wordsplit ${branch:+-b "$branch"...}
262                         case "$branch" in
263                         '') git checkout -f -q ;;
264                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265                         esac
266                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
267         fi
268         git config submodule."$sm_name".url "$realrepo"
269
270         git add $force "$sm_path" ||
271         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
272
273         git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
274         git config -f .gitmodules submodule."$sm_name".url "$repo" &&
275         if test -n "$branch"
276         then
277                 git config -f .gitmodules submodule."$sm_name".branch "$branch"
278         fi &&
279         git add --force .gitmodules ||
280         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
281
282         # NEEDSWORK: In a multi-working-tree world, this needs to be
283         # set in the per-worktree config.
284         if git config --get submodule.active >/dev/null
285         then
286                 # If the submodule being adding isn't already covered by the
287                 # current configured pathspec, set the submodule's active flag
288                 if ! git submodule--helper is-active "$sm_path"
289                 then
290                         git config submodule."$sm_name".active "true"
291                 fi
292         else
293                 git config submodule."$sm_name".active "true"
294         fi
295 }
296
297 #
298 # Execute an arbitrary command sequence in each checked out
299 # submodule
300 #
301 # $@ = command to execute
302 #
303 cmd_foreach()
304 {
305         # parse $args after "submodule ... foreach".
306         while test $# -ne 0
307         do
308                 case "$1" in
309                 -q|--quiet)
310                         GIT_QUIET=1
311                         ;;
312                 --recursive)
313                         recursive=1
314                         ;;
315                 -*)
316                         usage
317                         ;;
318                 *)
319                         break
320                         ;;
321                 esac
322                 shift
323         done
324
325         toplevel=$(pwd)
326
327         # dup stdin so that it can be restored when running the external
328         # command in the subshell (and a recursive call to this function)
329         exec 3<&0
330
331         {
332                 git submodule--helper list --prefix "$wt_prefix" ||
333                 echo "#unmatched" $?
334         } |
335         while read -r mode sha1 stage sm_path
336         do
337                 die_if_unmatched "$mode" "$sha1"
338                 if test -e "$sm_path"/.git
339                 then
340                         displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
341                         say "$(eval_gettext "Entering '\$displaypath'")"
342                         name=$(git submodule--helper name "$sm_path")
343                         (
344                                 prefix="$prefix$sm_path/"
345                                 sanitize_submodule_env
346                                 cd "$sm_path" &&
347                                 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
348                                 # we make $path available to scripts ...
349                                 path=$sm_path &&
350                                 if test $# -eq 1
351                                 then
352                                         eval "$1"
353                                 else
354                                         "$@"
355                                 fi &&
356                                 if test -n "$recursive"
357                                 then
358                                         cmd_foreach "--recursive" "$@"
359                                 fi
360                         ) <&3 3<&- ||
361                         die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
362                 fi
363         done
364 }
365
366 #
367 # Register submodules in .git/config
368 #
369 # $@ = requested paths (default to all)
370 #
371 cmd_init()
372 {
373         # parse $args after "submodule ... init".
374         while test $# -ne 0
375         do
376                 case "$1" in
377                 -q|--quiet)
378                         GIT_QUIET=1
379                         ;;
380                 --)
381                         shift
382                         break
383                         ;;
384                 -*)
385                         usage
386                         ;;
387                 *)
388                         break
389                         ;;
390                 esac
391                 shift
392         done
393
394         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet}  "$@"
395 }
396
397 #
398 # Unregister submodules from .git/config and remove their work tree
399 #
400 cmd_deinit()
401 {
402         # parse $args after "submodule ... deinit".
403         deinit_all=
404         while test $# -ne 0
405         do
406                 case "$1" in
407                 -f|--force)
408                         force=$1
409                         ;;
410                 -q|--quiet)
411                         GIT_QUIET=1
412                         ;;
413                 --all)
414                         deinit_all=t
415                         ;;
416                 --)
417                         shift
418                         break
419                         ;;
420                 -*)
421                         usage
422                         ;;
423                 *)
424                         break
425                         ;;
426                 esac
427                 shift
428         done
429
430         if test -n "$deinit_all" && test "$#" -ne 0
431         then
432                 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
433                 usage
434         fi
435         if test $# = 0 && test -z "$deinit_all"
436         then
437                 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
438         fi
439
440         {
441                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
442                 echo "#unmatched" $?
443         } |
444         while read -r mode sha1 stage sm_path
445         do
446                 die_if_unmatched "$mode" "$sha1"
447                 name=$(git submodule--helper name "$sm_path") || exit
448
449                 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
450
451                 # Remove the submodule work tree (unless the user already did it)
452                 if test -d "$sm_path"
453                 then
454                         # Protect submodules containing a .git directory
455                         if test -d "$sm_path/.git"
456                         then
457                                 die "$(eval_gettext "\
458 Submodule work tree '\$displaypath' contains a .git directory
459 (use 'rm -rf' if you really want to remove it including all of its history)")"
460                         fi
461
462                         if test -z "$force"
463                         then
464                                 git rm -qn "$sm_path" ||
465                                 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
466                         fi
467                         rm -rf "$sm_path" &&
468                         say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
469                         say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
470                 fi
471
472                 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
473
474                 # Remove the .git/config entries (unless the user already did it)
475                 if test -n "$(git config --get-regexp submodule."$name\.")"
476                 then
477                         # Remove the whole section so we have a clean state when
478                         # the user later decides to init this submodule again
479                         url=$(git config submodule."$name".url)
480                         git config --remove-section submodule."$name" 2>/dev/null &&
481                         say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
482                 fi
483         done
484 }
485
486 is_tip_reachable () (
487         sanitize_submodule_env &&
488         cd "$1" &&
489         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
490         test -z "$rev"
491 )
492
493 fetch_in_submodule () (
494         sanitize_submodule_env &&
495         cd "$1" &&
496         case "$2" in
497         '')
498                 git fetch ;;
499         *)
500                 shift
501                 git fetch $(get_default_remote) "$@" ;;
502         esac
503 )
504
505 #
506 # Update each submodule path to correct revision, using clone and checkout as needed
507 #
508 # $@ = requested paths (default to all)
509 #
510 cmd_update()
511 {
512         # parse $args after "submodule ... update".
513         while test $# -ne 0
514         do
515                 case "$1" in
516                 -q|--quiet)
517                         GIT_QUIET=1
518                         ;;
519                 -v)
520                         GIT_QUIET=0
521                         ;;
522                 --progress)
523                         progress="--progress"
524                         ;;
525                 -i|--init)
526                         init=1
527                         ;;
528                 --remote)
529                         remote=1
530                         ;;
531                 -N|--no-fetch)
532                         nofetch=1
533                         ;;
534                 -f|--force)
535                         force=$1
536                         ;;
537                 -r|--rebase)
538                         update="rebase"
539                         ;;
540                 --reference)
541                         case "$2" in '') usage ;; esac
542                         reference="--reference=$2"
543                         shift
544                         ;;
545                 --reference=*)
546                         reference="$1"
547                         ;;
548                 -m|--merge)
549                         update="merge"
550                         ;;
551                 --recursive)
552                         recursive=1
553                         ;;
554                 --checkout)
555                         update="checkout"
556                         ;;
557                 --recommend-shallow)
558                         recommend_shallow="--recommend-shallow"
559                         ;;
560                 --no-recommend-shallow)
561                         recommend_shallow="--no-recommend-shallow"
562                         ;;
563                 --depth)
564                         case "$2" in '') usage ;; esac
565                         depth="--depth=$2"
566                         shift
567                         ;;
568                 --depth=*)
569                         depth=$1
570                         ;;
571                 -j|--jobs)
572                         case "$2" in '') usage ;; esac
573                         jobs="--jobs=$2"
574                         shift
575                         ;;
576                 --jobs=*)
577                         jobs=$1
578                         ;;
579                 --)
580                         shift
581                         break
582                         ;;
583                 -*)
584                         usage
585                         ;;
586                 *)
587                         break
588                         ;;
589                 esac
590                 shift
591         done
592
593         if test -n "$init"
594         then
595                 cmd_init "--" "$@" || return
596         fi
597
598         {
599         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
600                 ${progress:+"$progress"} \
601                 ${wt_prefix:+--prefix "$wt_prefix"} \
602                 ${prefix:+--recursive-prefix "$prefix"} \
603                 ${update:+--update "$update"} \
604                 ${reference:+"$reference"} \
605                 ${depth:+--depth "$depth"} \
606                 ${recommend_shallow:+"$recommend_shallow"} \
607                 ${jobs:+$jobs} \
608                 "$@" || echo "#unmatched" $?
609         } | {
610         err=
611         while read -r mode sha1 stage just_cloned sm_path
612         do
613                 die_if_unmatched "$mode" "$sha1"
614
615                 name=$(git submodule--helper name "$sm_path") || exit
616                 url=$(git config submodule."$name".url)
617                 if ! test -z "$update"
618                 then
619                         update_module=$update
620                 else
621                         update_module=$(git config submodule."$name".update)
622                         if test -z "$update_module"
623                         then
624                                 update_module="checkout"
625                         fi
626                 fi
627
628                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
629
630                 if test $just_cloned -eq 1
631                 then
632                         subsha1=
633                         case "$update_module" in
634                         merge | rebase | none)
635                                 update_module=checkout ;;
636                         esac
637                 else
638                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
639                                 git rev-parse --verify HEAD) ||
640                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
641                 fi
642
643                 if test -n "$remote"
644                 then
645                         branch=$(git submodule--helper remote-branch "$sm_path")
646                         if test -z "$nofetch"
647                         then
648                                 # Fetch remote before determining tracking $sha1
649                                 fetch_in_submodule "$sm_path" $depth ||
650                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
651                         fi
652                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
653                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
654                                 git rev-parse --verify "${remote_name}/${branch}") ||
655                         die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
656                 fi
657
658                 if test "$subsha1" != "$sha1" || test -n "$force"
659                 then
660                         subforce=$force
661                         # If we don't already have a -f flag and the submodule has never been checked out
662                         if test -z "$subsha1" && test -z "$force"
663                         then
664                                 subforce="-f"
665                         fi
666
667                         if test -z "$nofetch"
668                         then
669                                 # Run fetch only if $sha1 isn't present or it
670                                 # is not reachable from a ref.
671                                 is_tip_reachable "$sm_path" "$sha1" ||
672                                 fetch_in_submodule "$sm_path" $depth ||
673                                 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
674
675                                 # Now we tried the usual fetch, but $sha1 may
676                                 # not be reachable from any of the refs
677                                 is_tip_reachable "$sm_path" "$sha1" ||
678                                 fetch_in_submodule "$sm_path" $depth "$sha1" ||
679                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
680                         fi
681
682                         must_die_on_failure=
683                         case "$update_module" in
684                         checkout)
685                                 command="git checkout $subforce -q"
686                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
687                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
688                                 ;;
689                         rebase)
690                                 command="git rebase"
691                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
692                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
693                                 must_die_on_failure=yes
694                                 ;;
695                         merge)
696                                 command="git merge"
697                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
698                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
699                                 must_die_on_failure=yes
700                                 ;;
701                         !*)
702                                 command="${update_module#!}"
703                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
704                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
705                                 must_die_on_failure=yes
706                                 ;;
707                         *)
708                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
709                         esac
710
711                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
712                         then
713                                 say "$say_msg"
714                         elif test -n "$must_die_on_failure"
715                         then
716                                 die_with_status 2 "$die_msg"
717                         else
718                                 err="${err};$die_msg"
719                                 continue
720                         fi
721                 fi
722
723                 if test -n "$recursive"
724                 then
725                         (
726                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
727                                 wt_prefix=
728                                 sanitize_submodule_env
729                                 cd "$sm_path" &&
730                                 eval cmd_update
731                         )
732                         res=$?
733                         if test $res -gt 0
734                         then
735                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
736                                 if test $res -ne 2
737                                 then
738                                         err="${err};$die_msg"
739                                         continue
740                                 else
741                                         die_with_status $res "$die_msg"
742                                 fi
743                         fi
744                 fi
745         done
746
747         if test -n "$err"
748         then
749                 OIFS=$IFS
750                 IFS=';'
751                 for e in $err
752                 do
753                         if test -n "$e"
754                         then
755                                 echo >&2 "$e"
756                         fi
757                 done
758                 IFS=$OIFS
759                 exit 1
760         fi
761         }
762 }
763
764 set_name_rev () {
765         revname=$( (
766                 sanitize_submodule_env
767                 cd "$1" && {
768                         git describe "$2" 2>/dev/null ||
769                         git describe --tags "$2" 2>/dev/null ||
770                         git describe --contains "$2" 2>/dev/null ||
771                         git describe --all --always "$2"
772                 }
773         ) )
774         test -z "$revname" || revname=" ($revname)"
775 }
776 #
777 # Show commit summary for submodules in index or working tree
778 #
779 # If '--cached' is given, show summary between index and given commit,
780 # or between working tree and given commit
781 #
782 # $@ = [commit (default 'HEAD'),] requested paths (default all)
783 #
784 cmd_summary() {
785         summary_limit=-1
786         for_status=
787         diff_cmd=diff-index
788
789         # parse $args after "submodule ... summary".
790         while test $# -ne 0
791         do
792                 case "$1" in
793                 --cached)
794                         cached="$1"
795                         ;;
796                 --files)
797                         files="$1"
798                         ;;
799                 --for-status)
800                         for_status="$1"
801                         ;;
802                 -n|--summary-limit)
803                         summary_limit="$2"
804                         isnumber "$summary_limit" || usage
805                         shift
806                         ;;
807                 --summary-limit=*)
808                         summary_limit="${1#--summary-limit=}"
809                         isnumber "$summary_limit" || usage
810                         ;;
811                 --)
812                         shift
813                         break
814                         ;;
815                 -*)
816                         usage
817                         ;;
818                 *)
819                         break
820                         ;;
821                 esac
822                 shift
823         done
824
825         test $summary_limit = 0 && return
826
827         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
828         then
829                 head=$rev
830                 test $# = 0 || shift
831         elif test -z "$1" || test "$1" = "HEAD"
832         then
833                 # before the first commit: compare with an empty tree
834                 head=$(git hash-object -w -t tree --stdin </dev/null)
835                 test -z "$1" || shift
836         else
837                 head="HEAD"
838         fi
839
840         if [ -n "$files" ]
841         then
842                 test -n "$cached" &&
843                 die "$(gettext "The --cached option cannot be used with the --files option")"
844                 diff_cmd=diff-files
845                 head=
846         fi
847
848         cd_to_toplevel
849         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
850         # Get modified modules cared by user
851         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
852                 sane_egrep '^:([0-7]* )?160000' |
853                 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
854                 do
855                         # Always show modules deleted or type-changed (blob<->module)
856                         if test "$status" = D || test "$status" = T
857                         then
858                                 printf '%s\n' "$sm_path"
859                                 continue
860                         fi
861                         # Respect the ignore setting for --for-status.
862                         if test -n "$for_status"
863                         then
864                                 name=$(git submodule--helper name "$sm_path")
865                                 ignore_config=$(get_submodule_config "$name" ignore none)
866                                 test $status != A && test $ignore_config = all && continue
867                         fi
868                         # Also show added or modified modules which are checked out
869                         GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
870                         printf '%s\n' "$sm_path"
871                 done
872         )
873
874         test -z "$modules" && return
875
876         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
877         sane_egrep '^:([0-7]* )?160000' |
878         cut -c2- |
879         while read -r mod_src mod_dst sha1_src sha1_dst status name
880         do
881                 if test -z "$cached" &&
882                         test $sha1_dst = 0000000000000000000000000000000000000000
883                 then
884                         case "$mod_dst" in
885                         160000)
886                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
887                                 ;;
888                         100644 | 100755 | 120000)
889                                 sha1_dst=$(git hash-object $name)
890                                 ;;
891                         000000)
892                                 ;; # removed
893                         *)
894                                 # unexpected type
895                                 eval_gettextln "unexpected mode \$mod_dst" >&2
896                                 continue ;;
897                         esac
898                 fi
899                 missing_src=
900                 missing_dst=
901
902                 test $mod_src = 160000 &&
903                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
904                 missing_src=t
905
906                 test $mod_dst = 160000 &&
907                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
908                 missing_dst=t
909
910                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
911
912                 total_commits=
913                 case "$missing_src,$missing_dst" in
914                 t,)
915                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
916                         ;;
917                 ,t)
918                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
919                         ;;
920                 t,t)
921                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
922                         ;;
923                 *)
924                         errmsg=
925                         total_commits=$(
926                         if test $mod_src = 160000 && test $mod_dst = 160000
927                         then
928                                 range="$sha1_src...$sha1_dst"
929                         elif test $mod_src = 160000
930                         then
931                                 range=$sha1_src
932                         else
933                                 range=$sha1_dst
934                         fi
935                         GIT_DIR="$name/.git" \
936                         git rev-list --first-parent $range -- | wc -l
937                         )
938                         total_commits=" ($(($total_commits + 0)))"
939                         ;;
940                 esac
941
942                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
943                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
944                 if test $status = T
945                 then
946                         blob="$(gettext "blob")"
947                         submodule="$(gettext "submodule")"
948                         if test $mod_dst = 160000
949                         then
950                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
951                         else
952                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
953                         fi
954                 else
955                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
956                 fi
957                 if test -n "$errmsg"
958                 then
959                         # Don't give error msg for modification whose dst is not submodule
960                         # i.e. deleted or changed to blob
961                         test $mod_dst = 160000 && echo "$errmsg"
962                 else
963                         if test $mod_src = 160000 && test $mod_dst = 160000
964                         then
965                                 limit=
966                                 test $summary_limit -gt 0 && limit="-$summary_limit"
967                                 GIT_DIR="$name/.git" \
968                                 git log $limit --pretty='format:  %m %s' \
969                                 --first-parent $sha1_src...$sha1_dst
970                         elif test $mod_dst = 160000
971                         then
972                                 GIT_DIR="$name/.git" \
973                                 git log --pretty='format:  > %s' -1 $sha1_dst
974                         else
975                                 GIT_DIR="$name/.git" \
976                                 git log --pretty='format:  < %s' -1 $sha1_src
977                         fi
978                         echo
979                 fi
980                 echo
981         done
982 }
983 #
984 # List all submodules, prefixed with:
985 #  - submodule not initialized
986 #  + different revision checked out
987 #
988 # If --cached was specified the revision in the index will be printed
989 # instead of the currently checked out revision.
990 #
991 # $@ = requested paths (default to all)
992 #
993 cmd_status()
994 {
995         # parse $args after "submodule ... status".
996         while test $# -ne 0
997         do
998                 case "$1" in
999                 -q|--quiet)
1000                         GIT_QUIET=1
1001                         ;;
1002                 --cached)
1003                         cached=1
1004                         ;;
1005                 --recursive)
1006                         recursive=1
1007                         ;;
1008                 --)
1009                         shift
1010                         break
1011                         ;;
1012                 -*)
1013                         usage
1014                         ;;
1015                 *)
1016                         break
1017                         ;;
1018                 esac
1019                 shift
1020         done
1021
1022         {
1023                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1024                 echo "#unmatched" $?
1025         } |
1026         while read -r mode sha1 stage sm_path
1027         do
1028                 die_if_unmatched "$mode" "$sha1"
1029                 name=$(git submodule--helper name "$sm_path") || exit
1030                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1031                 if test "$stage" = U
1032                 then
1033                         say "U$sha1 $displaypath"
1034                         continue
1035                 fi
1036                 if ! git submodule--helper is-active "$sm_path" ||
1037                 {
1038                         ! test -d "$sm_path"/.git &&
1039                         ! test -f "$sm_path"/.git
1040                 }
1041                 then
1042                         say "-$sha1 $displaypath"
1043                         continue;
1044                 fi
1045                 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1046                 then
1047                         set_name_rev "$sm_path" "$sha1"
1048                         say " $sha1 $displaypath$revname"
1049                 else
1050                         if test -z "$cached"
1051                         then
1052                                 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1053                         fi
1054                         set_name_rev "$sm_path" "$sha1"
1055                         say "+$sha1 $displaypath$revname"
1056                 fi
1057
1058                 if test -n "$recursive"
1059                 then
1060                         (
1061                                 prefix="$displaypath/"
1062                                 sanitize_submodule_env
1063                                 wt_prefix=
1064                                 cd "$sm_path" &&
1065                                 eval cmd_status
1066                         ) ||
1067                         die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1068                 fi
1069         done
1070 }
1071 #
1072 # Sync remote urls for submodules
1073 # This makes the value for remote.$remote.url match the value
1074 # specified in .gitmodules.
1075 #
1076 cmd_sync()
1077 {
1078         while test $# -ne 0
1079         do
1080                 case "$1" in
1081                 -q|--quiet)
1082                         GIT_QUIET=1
1083                         shift
1084                         ;;
1085                 --recursive)
1086                         recursive=1
1087                         shift
1088                         ;;
1089                 --)
1090                         shift
1091                         break
1092                         ;;
1093                 -*)
1094                         usage
1095                         ;;
1096                 *)
1097                         break
1098                         ;;
1099                 esac
1100         done
1101         cd_to_toplevel
1102         {
1103                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1104                 echo "#unmatched" $?
1105         } |
1106         while read -r mode sha1 stage sm_path
1107         do
1108                 die_if_unmatched "$mode" "$sha1"
1109
1110                 # skip inactive submodules
1111                 if ! git submodule--helper is-active "$sm_path"
1112                 then
1113                         continue
1114                 fi
1115
1116                 name=$(git submodule--helper name "$sm_path")
1117                 url=$(git config -f .gitmodules --get submodule."$name".url)
1118
1119                 # Possibly a url relative to parent
1120                 case "$url" in
1121                 ./*|../*)
1122                         # rewrite foo/bar as ../.. to find path from
1123                         # submodule work tree to superproject work tree
1124                         up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1125                         # guarantee a trailing /
1126                         up_path=${up_path%/}/ &&
1127                         # path from submodule work tree to submodule origin repo
1128                         sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1129                         # path from superproject work tree to submodule origin repo
1130                         super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1131                         ;;
1132                 *)
1133                         sub_origin_url="$url"
1134                         super_config_url="$url"
1135                         ;;
1136                 esac
1137
1138                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1139                 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1140                 git config submodule."$name".url "$super_config_url"
1141
1142                 if test -e "$sm_path"/.git
1143                 then
1144                 (
1145                         sanitize_submodule_env
1146                         cd "$sm_path"
1147                         remote=$(get_default_remote)
1148                         git config remote."$remote".url "$sub_origin_url"
1149
1150                         if test -n "$recursive"
1151                         then
1152                                 prefix="$prefix$sm_path/"
1153                                 eval cmd_sync
1154                         fi
1155                 )
1156                 fi
1157         done
1158 }
1159
1160 cmd_absorbgitdirs()
1161 {
1162         git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1163 }
1164
1165 # This loop parses the command line arguments to find the
1166 # subcommand name to dispatch.  Parsing of the subcommand specific
1167 # options are primarily done by the subcommand implementations.
1168 # Subcommand specific options such as --branch and --cached are
1169 # parsed here as well, for backward compatibility.
1170
1171 while test $# != 0 && test -z "$command"
1172 do
1173         case "$1" in
1174         add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1175                 command=$1
1176                 ;;
1177         -q|--quiet)
1178                 GIT_QUIET=1
1179                 ;;
1180         -b|--branch)
1181                 case "$2" in
1182                 '')
1183                         usage
1184                         ;;
1185                 esac
1186                 branch="$2"; shift
1187                 ;;
1188         --cached)
1189                 cached="$1"
1190                 ;;
1191         --)
1192                 break
1193                 ;;
1194         -*)
1195                 usage
1196                 ;;
1197         *)
1198                 break
1199                 ;;
1200         esac
1201         shift
1202 done
1203
1204 # No command word defaults to "status"
1205 if test -z "$command"
1206 then
1207     if test $# = 0
1208     then
1209         command=status
1210     else
1211         usage
1212     fi
1213 fi
1214
1215 # "-b branch" is accepted only by "add"
1216 if test -n "$branch" && test "$command" != add
1217 then
1218         usage
1219 fi
1220
1221 # "--cached" is accepted only by "status" and "summary"
1222 if test -n "$cached" && test "$command" != status && test "$command" != summary
1223 then
1224         usage
1225 fi
1226
1227 "cmd_$command" "$@"